#include "DeerStudio/EditorEngine.h"
#include "DeerStudio/EditorEngine/ErrorHandle.h"
#include "DeerStudio/EditorEngine/API.h"
#include "DeerStudio/EditorEngine/API_Registration.h"

#include "scripthandle.h"
#include "scriptany.h"
#include "angelscript.h"

namespace Deer {
    void EditorEngine::registerUIFunctions() {

        scriptEngine->SetDefaultNamespace("UI");
        REGISTER_GLOBAL_FUNC("bool button(const string& in)", button);
        REGISTER_GLOBAL_FUNC("bool buttonCenter(const string&in)", buttonCenter);
        REGISTER_GLOBAL_FUNC("bool buttonEnd(const string&in)", buttonEnd);
        REGISTER_GLOBAL_FUNC("bool checkbox(const string& in, bool)", checkbox);
        REGISTER_GLOBAL_FUNC("bool checkboxDisabled(const string& in, bool)", checkboxDisabled);
        REGISTER_GLOBAL_FUNC("void drawFrameBuffer(FrameBuffer, int, int)", drawFrameBuffer);
        REGISTER_GLOBAL_FUNC("void drawFrameBufferCentered(FrameBuffer, int, int)", drawFrameBufferCentered);
        REGISTER_GLOBAL_FUNC("void drawIcon(const string& in, int)", drawIcon);
        REGISTER_GLOBAL_FUNC("void drawIconCentered(const string& in, int)", drawIconCentered);
        REGISTER_GLOBAL_FUNC("bool inputText(const string& in, const string& in, string& out)", inputText);
        REGISTER_GLOBAL_FUNC("bool isItemClicked(int)", isItemClicked);
        REGISTER_GLOBAL_FUNC("bool isMouseDoubleClicked(int)", isMouseDoubleClicked);
        REGISTER_GLOBAL_FUNC("float magicSlider(const string& in, float, float)", magicSlider);
        REGISTER_GLOBAL_FUNC("vec3 magicSlider3(const string& in, vec3, float)", magicSlider3);
        REGISTER_GLOBAL_FUNC("bool menuItem(const string& in)", menuItem);
        REGISTER_GLOBAL_FUNC("void menuItemDisabled(const string& in)", menuItemDisabled);
        REGISTER_GLOBAL_FUNC("void menuSpace(const string& in, any@+, ReciverFunc@+)", menuSpace);
        REGISTER_GLOBAL_FUNC("void sameline()", sameline);
        REGISTER_GLOBAL_FUNC("void separator()", separator);
        REGISTER_GLOBAL_FUNC("void space()", space);
        REGISTER_GLOBAL_FUNC("void space(int, int = 10)", space_params);
        REGISTER_GLOBAL_FUNC("void text(const string& in)", text);
        REGISTER_GLOBAL_FUNC("void textCenter(const string& in)", textCenter);
        REGISTER_GLOBAL_FUNC("void textColor(float, float, float, const string& in)", textColor);
        REGISTER_GLOBAL_FUNC("void textEnd(const string& in)", textEnd);
        REGISTER_GLOBAL_FUNC("void title(const string&in)", title);
        REGISTER_GLOBAL_FUNC("void titleCenter(const string&in)", titleCenter);
        REGISTER_GLOBAL_FUNC("void titleCenterY(const string&in, int)", titleCenterY);
        REGISTER_GLOBAL_FUNC("void titleEnd(const string&in)", titleEnd);
        scriptEngine->SetDefaultNamespace("");
    }
}